# Torf & Brauer exercises
# p.s. remember to use the correct working directory

# Compute the difference between 2017 and the
# year you started at this university and divide
# this by the difference between 2017 and the year
# you were born. Multiply this with 100 to get
# the percentage of your life you have spent at
# this university. Use brackets if you need them.

(2017 - 2015)/(2017 - 1996) * 100 

# Repeat the previous ToDo, but with several
# steps in between. You can give the variables
# any name you want, but the name has to start
# with a letter

current <- 2017
uni_start <- 2015
birth <- 1996
uni_life <- (current - uni_start)/(current - birth) * 100
uni_life

# Compute the sum of 4, 5, 8 and 11 by first com-
# bining them into a vector and then using the
# function sum.

ex_vector <- c(4, 5, 8, 11)
sum(ex_vector)
 
# Plot 100 normal random numbers.

plot(rnorm(100, mean = 0, sd = 2))


# Find help for the sqrt function.

?sqrt


# Make a file called firstscript.R containing R-
# code that generates 100 random numbers and
# plots them, and run this script several times.

source("firstscript.R") 
source("firstscript.R")
source("firstscript.R")

# Put the numbers 31 to 60 in a vector named
# P and in a matrix with 6 rows and 5 columns
# named Q. Tip: use the function seq. Look at
# the different ways scalars, vectors and matrices
# are denoted in the workspace window.

P <- seq(from = 31, to = 60)
# my_seq <- 31:60 # an easier way
is.vector(P)
is.matrix(P)
M <- matrix(P, ncol = 5, nrow = 6)
is.vector(M)
is.matrix(M)

# Make a script file which constructs three ran-
# dom normal vectors of length 100. Call these
# vectors x1, x2 and x3. Make a data frame called
# t with three columns (called a, b and c) con-
# taining respectively x1, x1+x2 and x1+x2+x3.
# Call the following functions for this data frame:
# plot(t) and sd(t). Can you understand the
# results? Rerun this script a few times.

source("secondscript.R")

source("secondscript.R")

source("secondscript.R")

# Add these lines to the script file of the previous
# section. Try to find out, either by experiment-
# ing or by using the help, what the meaning is of
# rgb, the last argument of rgb, lwd, pch, cex.


source("thirdscript.R")

source("thirdscript.R")

source("thirdscript.R")

# Make a file called tst1.txt in Notepad from
# the example in Figure 4 and store it in your
# working directory. Write a script to read it, to
# multiply the column called g by 5 and to store
# it as tst2.txt.

txt1 <- read.table("tst1.txt", header = T)
txt1$g <- txt1$g * 5
write.table(x = txt1, file = "tst2.txt", row.names=FALSE)

# Compute the mean of the square root of a vec-
#   tor of 100 random numbers. What happens?

mean(sqrt(rnorm(n = 100)))

# Make a graph with on the x-axis: today, Sin-
# terklaas 2017 and your next birthday and on
# the y-axis the number of presents you expect on
# each of these days. Tip: make two vectors first.

dates <- strptime(c("20171015", "20171119", "20180809"), format = "%Y%m%d")
presents <- c(2, 0, 17)
plot(y = presents, x = dates, col = "red", pch =16)

# Make a vector from 1 to 100. Make a for-loop
# which runs through the whole vector. Multiply
# the elements which are smaller than 5 and larger
# than 90 with 10 and the other elements with 0.1.

temp <- 1:100
for (i in 1:100){
  if (temp[i] < 5 | temp[i] > 90){
    temp[i] <- temp[i]*10
  }
  else{
    temp[i] <- temp[i]*0.1
  }
}

 
# Write a function for the previous ToDo, so
# that you can feed it any vector you like
# (as argument). Use a for-loop in the func-
# tion to do the computation with each ele-
# ment. Use the standard R function length
# in the specification of the counter.

my_fun <- function(x){
  if(is.vector(x) == FALSE){stop("Argument is not a vector!")}
  
  l <- length(x)
  
  for (i in 1:l){
    if (x[i] < 5 | x[i] > 90){
      x[i] <- x[i]*10
    }
    else{
      x[i] <- x[i]*0.1
    }
  }
  return(x)
}


