my_mean <- 0
my_sd <- 1

x1 <- rnorm(n = 100, mean = my_mean, sd = my_sd)
x2 <- rnorm(n = 100, mean = my_mean, sd = my_sd)
x3 <- rnorm(n = 100, mean = my_mean, sd = my_sd)

t <- data.frame(a = x1, b = x1+x2, c = x1+x2+x3)
plot(t)
# sd(t) this won't work for R versions >= 3.0.0 
print(var(t)) # print() is needed to force R to show the output

plot(t$a, type="l", ylim=range(t),
     lwd=3, col=rgb(1,0,0,0.3))
lines(t$b, type="s", lwd=2,
        col=rgb(0.3,0.4,0.3,0.9))
points(t$c, pch=20, cex=4,
         col=rgb(0,0,1,0.3))